Ask Your Question
0

Installation of ros-base on debian stretch

asked 2018-08-22 06:32:47 -0600

segmentation_fault gravatar image

I want to install ros-base pkg(likely Melodic) on an Beaglebone Black Debian Stretch Image. link text

Unfortunately I am confused now:

Firstly there are no melodic nor kinetic packages available after updating and

 sudo sh -c 'echo "deb http://packages.ros.org/ros/ubuntu $(lsb_release -sc) main" > /etc/apt/sources.list.d/ros-latest.list'

Instead I can install ros-core, ros-base I tried:

sudo apt-get install build-essential libboost-all-dev device-tree-compiler schedtool screen chrony cgroup-lite
sudo apt-get install python-scipy ipython python-qt4
sudo apt-get install dirmngr
sudo apt-get install cmake python-empy python-nose libgtest-dev
sudo apt-get install python-rosdep python-rosinstall-generator python-wstool python-rosinstall build-essential
sudo apt install python-dynamic-reconfigure python-catkin-pkg python-rospkg-modules python-roslib python-rospkg python-rosbag python-roslaunch python-rosmsg python-rostopic python-roswtf ros-core ros-base

Secondly I get:

The following packages have unmet dependencies:
catkin : Depends: python-catkin-pkg but it is not going to be installed
E: Unable to correct problems, you have held broken packages.
debian@beaglebone:~$ sudo apt install python-catkin-pkg
Reading package lists... Done
Building dependency tree       
Reading state information... Done
python-catkin-pkg is already the newest version (0.4.8-100).

So catkin wants python-catkin-pkg , which is said to be installed already. :( What do I have to do?

edit retag flag offensive close merge delete

1 Answer

Sort by ยป oldest newest most voted
1

answered 2018-08-22 06:45:53 -0600

gvdhoorn gravatar image

updated 2018-08-22 06:56:24 -0600

I want to install ros-base pkg [..] on [..] Debian Stretch Image. [..] Firstly there are no melodic nor kinetic packages available after updating

Both the installation instructions (wiki/kinetic/Installation) as well as REP-3 (Platforms by Distribution: Kinetic Kame (May 2016 - May 2021)) state that only Debian Jessie is supported for Kinetic.

Melodic should be supported (REP-3), provided you are using a platform for which binary pkgs are being built. Only amd64 and arm64 (or ARMv8) are supported (as can be seen on the installation page for Melodic).

If I'm not mistaken, a Beaglebone Black comes with a Cortex-A8 processor, which is a 32-bit CPU supporting ARMv7. The ROS buildfarm does not build binary pkgs for that afaik.

Instead I can install ros-core, ros-base

This is most likely because of wiki/UpstreamPackages.


Edit: as REP-3 mentions, packages are provided for arm32 for Melodic (and Lunar, and Kinetic). Those are grouped under the "hard float" moniker on the buildfarm. However, those are only built for the Ubuntu OS compatible with that architecture.

See also the various status pages available at repositories.ros.org/status_page.

The mapping used there:

  • default: Ubuntu (at the version targeted by the specific ROS release, and on amd64)
  • dj: Debian Jessie (on amd64)
  • djv8: Debian Jessie on ARMv8
  • uxhf: Ubuntu Xenial on Hard Float (ie: ARMv7 / 32bit)
  • uxv8: Ubuntu Xenial on ARMv8

Then ub is Ubuntu Bionic, ds is Debian Stretch, and so on.

edit flag offensive delete link more

Comments

Thank you very much! Then there is no other way then to downgrade the BB to Debian Jessy, right? :(

segmentation_fault gravatar imagesegmentation_fault ( 2018-08-22 06:55:49 -0600 )edit
1

Or use Ubuntu.

Or build ROS from sources.

gvdhoorn gravatar imagegvdhoorn ( 2018-08-22 06:56:58 -0600 )edit

See also #q285963 btw, which is actually a straight duplicate of this question.

gvdhoorn gravatar imagegvdhoorn ( 2018-08-22 07:02:13 -0600 )edit
1

If you're into embedded development / deployment, you might be interested in bmwcarit/meta-ros. It would provide a bit more of a structured way of deploying onto 'unsupported' embedded platforms (unsupported meaning: no binary pkgs available).

gvdhoorn gravatar imagegvdhoorn ( 2018-08-22 07:03:54 -0600 )edit

Your Answer

Please start posting anonymously - your entry will be published after you log in or create a new account.

Add Answer

Question Tools

1 follower

Stats

Asked: 2018-08-22 06:32:47 -0600

Seen: 1,218 times

Last updated: Aug 22 '18